
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  clrRed

//
//
//
//
//

extern int                BandsPeriod    = 20;
extern ENUM_APPLIED_PRICE BandsPrice     = 0;
extern double             BandsDeviation = 2.0;
extern int                BandsShift     = 0;

double BWIBuffer[];

//
//
//
//
//

int init() 
{   
  SetIndexBuffer(0, BWIBuffer);
  IndicatorShortName("Bandwidth");
return(0); 
}

int deinit() { return(0); }

//
//
//
//
//


int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars-1);
   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0; i--)
   {
      double mb = iBands(NULL,0,BandsPeriod,BandsDeviation,BandsShift,BandsPrice,0,i);
      double ub = iBands(NULL,0,BandsPeriod,BandsDeviation,BandsShift,BandsPrice,1,i);
      double lb = iBands(NULL,0,BandsPeriod,BandsDeviation,BandsShift,BandsPrice,2,i);
      double diff   = (ub-lb)/2;
              if (diff != 0)
                   BWIBuffer[i]=((ub-lb)/mb)*100;
              else BWIBuffer[i]=0;
   }
return(0);
}